typedef int LV;

void           addbuiltins    (void);
int            bin_enable     (char *, char **, char *, int);
int            bin_colon      (char *, char **, char *, int);
int            bin_break      (char *, char **, char *, int);
int            bin_fg         (char *, char **, char *, int);
int            bin_let        (char *, char **, char *, int);
int            zexit          (int);
int            optlookup      (char *);
int            bin_setopt     (char *, char **, char *, int);
void           listhtable     (Hashtab, HFunc);
void           pshfunc        (char *, Cmdnam);
void           niceprint      (char *);
void           niceprintf     (char *, FILE *);
int            bin_umask      (char *, char **, char *, int);
int            bin_whence     (char *, char **, char *, int);
int            bin_cd         (char *, char **, char *, int);
char          *cd_get_dest    (char *, char **, char *, int);
char          *cd_do_chdir    (char *, char *);
char          *cd_try_chdir   (char *, char *);
int            fixdir         (char *, char *);
void           cd_new_pwd     (int, char *);
void           convertwd      (char *, char *, int);
int            bin_rehash     (char *, char **, char *, int);
int            bin_hash       (char *, char **, char *, int);
int            prefix         (char *, char *);
int            getjob         (char *, char *);
int            findjobnam     (char *);
int            isanum         (char *);
int            bin_kill       (char *, char **, char *, int);
int            bin_limit      (char *, char **, char *, int);
int            bin_unlimit    (char *, char **, char *, int);
void           showlimits     (int, int);
int            bin_sched      (char *, char **, char *, int);
int            bin_eval       (char *, char **, char *, int);
int            fcgetcomm      (char *);
int            fcsubs         (char **, struct asgment *);
int            fclist         (FILE *, int, int, int, int, int, int,
                               struct asgment *);
int            fcedit         (char *, char *);
int            bin_fc         (char *, char **, char *, int);
int            bin_suspend    (char *, char **, char *, int);
int            bin_alias      (char *, char **, char *, int);
void           printalias     (char *, struct alias *);
void           printparam     (char *, Param);
int            bin_typeset    (char *, char **, char *, int);
char          *escsubst       (char *, int *);
int            bin_print      (char *, char **, char *, int);
int            bin_dirs       (char *, char **, char *, int);
int            bin_unalias    (char *, char **, char *, int);
int            bin_disable    (char *, char **, char *, int);
int            bin_unhash     (char *, char **, char *, int);
int            bin_unset      (char *, char **, char *, int);
int            zread          (void);
int            bin_read       (char *, char **, char *, int);
int            bin_vared      (char *, char **, char *, int);
int            execbin        (Lklist, Cmdnam);
struct asgment *getasg        (char *);
int            bin_dot        (char *, char **, char *, int);
int            bin_set        (char *, char **, char *, int);
int            bin_times      (char *, char **, char *, int);
int            bin_getopts    (char *, char **, char *, int);
int            getsignum      (char *);
int            bin_trap       (char *, char **, char *, int);
void           printulimit    (int, int);
int            bin_ulimit     (char *, char **, char *, int);
int            putraw         (int);
int            bin_echotc     (char *, char **, char *, int);
int            bin_pwd        (char *, char **, char *, int);
int            bin_test       (char *, char **, char *, int);
Cond           partest        (int);
int            bin_compctl    (char *, char **, char *, int);
void           printcompctl   (char *, Compctl);
void           compctl_process (char **, int, char *);
int            bin_ttyctl     (char *, char **, char *, int);
int            evalcond       (Cond);
int            doaccess       (char *, int);
struct stat   *getstat        (char *);
unsigned short dostat         (char *);
unsigned short dolstat        (char *);
int            optison        (char *);
List           parselstring   (char *);
void           execstring     (char *);
int            phork          (void);
int            execcursh      (Cmd);
int            zexecve        (char *, char **);
void           execute        (int);
char          *findcmd        (char *);
int            iscom          (char *);
int            isrelative     (char *);
int            hashcmd        (char *, char **);
void           fullhash       (void);
void           execlist       (List);
void           execlist2      (Sublist, int, int);
int            execpline      (Sublist, int, int);
void           execpline2     (Pline, int, int, int, int);
char         **makecline      (struct lklist *);
void           fixcline       (Lklist);
void           untokenize     (char *);
int            dontclob       (struct redir *);
void           closemn        (struct multio **, int);
void           closemnodes    (struct multio **);
void           addfd          (int, int *, struct multio **, int, int, int);
void           addvars        (Lklist, int);
void           execcmd        (Cmd, int, int, int, int);
void           fixfds         (int *);
void           entersubsh     (int);
void           closem         (void);
char          *gethere        (char *, int);
int            getherestr     (struct redir *);
void           catproc        (struct multio *);
void           teeproc        (struct multio *);
void           closeallelse   (struct multio *);
long int       zstrtol        (char *, char **, int);
Lklist         getoutput      (char *, int);
Lklist         readoutput     (int, int);
char          *getoutputfile  (char *);
char          *namedpipe      (void);
char          *getoutproc     (char *);
char          *getinproc      (char *);
int            getinpipe      (char *);
int            getoutpipe     (char *);
void           runlist        (List);
char          *gettemp        (void);
char          *zgetwd         (void);
void           mpipe          (int *);
void           spawnpipes     (Lklist);
int            exectime       (Cmd);
int            execfuncdef    (Cmd);
int            execcond       (Cmd);
void           execshfunc     (Cmd, Cmdnam);
void           doshfuncnoval  (List, Lklist, int);
void           doshfunc       (List, Lklist, int);
List           getfpfunc      (char *);
int            cancd          (char *);
int            cancd2         (char *);
void           glob           (Lklist, Lknode *);
long           qgetnum        (char **);
int            notstrcmp      (char **, char **);
int            forstrcmp      (char **, char **);
void           insert         (char *);
int            haswilds       (char *);
int            hasbraces      (char *);
int            xpandredir     (struct redir *, Lklist);
char          *dyncat         (char *, char *);
char          *tricat         (char *, char *, char *);
void           xpandbraces    (Lklist, Lknode *);
char          *getparen       (char *);
int            matchpat       (char *, char *);
void           getmatch       (char **, char *, int);
char          *getfullpath    (char *);
void           scanner        (Complist);
int            minimatch      (char **, char **);
int            domatch        (char *, Comp, int);
int            doesmatch      (Comp);
Complist       parsepat       (char *);
Comp           parsereg       (char *);
Complist       parsecomplist  (void);
Comp           parsecomp      (void);
Comp           parsecompsw    (void);
int            patmatch       (char *, char *);
void           remnulargs     (char *);
int            qualdev        (struct stat *, long);
int            qualnlink      (struct stat *, long);
int            qualuid        (struct stat *, long);
int            qualgid        (struct stat *, long);
int            qualisdev      (struct stat *, long);
int            qualmode       (struct stat *, long);
int            qualflags      (struct stat *, long);
int            qualiscom      (struct stat *, long);
int            qualsize       (struct stat *, long);
int            qualtime       (struct stat *, long);
void           hwaddc         (int);
int            hgetc          (void);
void           clearalstack   (void);
int            hgetch         (void);
char          *hgets          (char *, int);
void           hungets        (char *);
void           hungetc        (int);
void           hungetch       (int);
void           strinbeg       (void);
void           strinend       (void);
int            stuff          (char *);
void           hflush         (void);
void           hbegin         (void);
void           inittty        (void);
int            hend           (void);
void           remhist        (void);
void           hwbegin        (void);
char          *hwadd          (void);
int            getargspec     (int, int);
int            hconsearch     (char *, int *);
int            hcomsearch     (char *);
int            remtpath       (char **);
int            remtext        (char **);
int            rembutext      (char **);
int            remlpaths      (char **);
int            makeuppercase  (char **);
int            makelowercase  (char **);
void           subst          (char **, char *, char *, int);
char          *convamps       (char *, char *);
char          *makehstr       (char *);
char          *quietgetevent  (int);
char          *getevent       (int);
int            getargc        (char *);
char          *getargs        (char *, int, int);
void           upcase         (char **);
void           downcase       (char **);
int            quote          (char **);
int            quotebreak     (char **);
void           herrflush      (void);
char          *hdynread       (int);
char          *hdynread2      (int);
void           inithist       (void);
void           resizehistents (void);
char          *hp_alloc       (Hp *, int);
char          *hp_realloc     (Hp *, char *, int, int);
void           hp_free        (Hp, char *, int);
char          *hp_concat      (char *, char *);
void           hp_purge       (Hp, int);
void           readhistfile   (char *, int);
void           savehistfile   (char *, int, int);
int            firsthist      (void);
void           main           (int, char **, char **);
void           loop           (int);
void           setflags       (const char *);
void           parseargs      (char **);
void           setmoreflags   (void);
void           setupvals      (void);
void           compctlsetup   (void);
void           initialize     (void);
void           addreswords    (void);
void           runscripts     (char *);
void           ainit          (void);
HANDTYPE       handler        (int);
void           makerunning    (Job);
void           updatestatus   (Job);
void           findproc       (int, Job *, struct process **);
void           printjob       (Job, int);
void           setprevjob     (void);
void           initjob        (void);
struct process *addproc       (long, char *);
int            execok         (void);
void           waitforpid     (long);
void           waitjob        (int);
void           waitjobs       (void);
void           clearjobtab    (void);
int            getfreejob     (void);
void           spawnjob       (void);
void           fixsigs        (void);
int            report         (Job);
void           printtime      (time_t, struct timeinfo *, char *);
void           dumptime       (Job);
void           shelltime      (void);
void           killrunjobs    (void);
void           checkjobs      (void);
int            killjb         (Job, int);
void           lexsave        (void);
void           lexrestore     (void);
void           yylex          (void);
void           ctxtlex        (void);
void           initlextabs    (void);
void           lexinit        (void);
void           add            (int);
int            gettok         (void);
int            exalias        (void);
int            skipcomm       (void);
int            execfor        (Cmd);
int            execselect     (Cmd);
int            execwhile      (Cmd);
int            execrepeat     (Cmd);
int            execif         (Cmd);
int            execcase       (Cmd);
int            zzlex          (void);
void           push           (long, LV);
long           getvar         (LV);
long           setvar         (LV, long);
int            notzero        (int);
void           op             (int);
void           bop            (int);
long           mathevall      (char *, int, char **);
long           matheval       (char *);
long           mathevalarg    (char *, char **);
void           mathparse      (int);
void           meminit        (void);
void           heapalloc      (void);
void           permalloc      (void);
void           lastalloc      (void);
void           pushheap       (void);
void           freeheap       (void);
void           popheap        (void);
void           freeh          (Heap);
vptr           halloc         (int);
vptr           hcalloc        (int);
vptr           hrealloc       (char *, int, int);
vptr           zalloc         (int);
vptr           zcalloc        (int);
char          *strdup         (const char *);
char          *ztrdup         (const char *);
void           setupparams    (void);
struct param  *createparam    (char *, vptr, int);
int            isident        (char *);
Value          getvalue       (char **, int);
char          *getstrvalue    (Value);
char         **getarrvalue    (Value);
long           getintvalue    (Value);
void           setstrvalue    (Value, char *);
void           setintvalue    (Value, long);
void           setintenv      (char *, long);
void           setarrvalue    (Value, char **);
int            getparamtype   (char *, int);
char          *getsparamval   (char *, int);
long           getiparam      (char *);
char          *getsparam      (char *);
char         **getaparam      (char *);
Param          setsparam      (char *, char *);
Param          setaparam      (char *, char **);
Param          setiparam      (char *, long);
void           unsetparam     (char *);
void           intsetfn       (Param, long);
long           intgetfn       (Param);
void           strsetfn       (Param, char *);
char          *strgetfn       (Param);
void           nullsetfn      (Param, char *);
void           arrsetfn       (Param, char **);
char         **arrgetfn       (Param);
void           intvarsetfn    (Param, long);
long           intvargetfn    (Param);
void           strvarsetfn    (Param, char *);
void           strvarnonullsetfn (Param, char *);
char          *strvargetfn    (Param);
char          *strconstgetfn  (Param);
void           colonarrsetfn  (Param, char *);
char          *colonarrgetfn  (Param);
char         **arrvargetfn    (Param);
void           arrvarsetfn    (Param, char **);
char         **pathgetfn      (Param);
void           pathsetfn      (Param, char **);
void           hostcmdssetfn  (Param, char **);
void           optcmdssetfn   (Param, char **);
void           bindcmdssetfn  (Param, char **);
void           varcmdssetfn   (Param, char **);
char         **nullgetfn      (Param);
void           unsettablesetfn (Param, char *);
long           poundgetfn     (Param);
long           randomgetfn    (Param);
void           randomsetfn    (Param, long);
long           secondsgetfn   (Param);
void           secondssetfn   (Param, long);
long           uidgetfn       (Param);
long           gidgetfn       (Param);
char          *usernamegetfn  (Param);
char          *hostgetfn      (Param);
char          *ifsgetfn       (Param);
void           ifssetfn       (Param, char *);
void           histsizesetfn  (Param, long);
long           histsizegetfn  (Param);
void           lithistsizesetfn (Param, long);
long           lithistsizegetfn (Param);
void           mailchecksetfn (Param, long);
void           pathasetfn     (Param, char **);
char         **pathagetfn     (Param);
long           errnogetfn     (Param);
char          *dashgetfn      (Param);
void           histcharssetfn (Param, char *);
char          *histcharsgetfn (Param);
char          *homegetfn      (Param);
void           homesetfn      (Param, char *);
char          *wordcharsgetfn (Param);
void           wordcharssetfn (Param, char *);
char          *underscoregetfn (Param);
char          *termgetfn      (Param);
void           termsetfn      (Param, char *);
void           setparams      (void);
char          *mkenvstr       (char *, char *);
void           arrfixenv      (char *, char **);
char          *replenv        (char *, char *);
char          *addenv         (char *, char *);
void           delenv         (char *);
void           convbase       (char *, long, int);
List           parse_event    (void);
List           par_event      (void);
List           parse_list     (void);
List           par_list       (void);
List           par_list1      (void);
Sublist        par_sublist    (void);
Sublist        par_sublist2   (void);
Pline          par_pline      (void);
Cmd            par_cmd        (void);
void           par_for        (Cmd);
void           par_case       (Cmd);
void           par_if         (Cmd);
void           par_while      (Cmd);
void           par_repeat     (Cmd);
void           par_subsh      (Cmd);
void           par_funcdef    (Cmd);
void           par_time       (Cmd);
void           par_dinbrack   (Cmd);
Cmd            par_simple     (Cmd);
Cond           par_cond       (void);
Cond           par_cond_1     (void);
Cond           par_cond_2     (void);
void           par_redir      (Lklist);
Lklist         par_wordlist   (void);
Lklist         par_nl_wordlist (void);
int            getfdstr       (char *);
Cond           par_cond_double (char *, char *);
Cond           par_cond_triple (char *, char *, char *);
void           yyerror        (void);
void           prefork        (Lklist);
void           postfork       (Lklist, int);
void           singsub        (char **);
vptr           nstrdup        (vptr);
char          *dynread        (int);
int            filesub        (char **);
char          *gethome        (char *, int);
void           commsubst      (Lklist, Lknode, char *, char *, int);
void           paramsubst     (Lklist, Lknode, char *, char *, int);
void           arithsubst     (vptr *, char **);
void           modify         (char **, char **);
char          *dstackent      (int);
struct alias  *mkanode        (char *, int);
Lklist         newlist        (void);
Hashtab        newhtable      (int);
int            hasher         (char *);
void           Addhnode       (char *, vptr, Hashtab, FFunc, int);
void           addhcmdnode    (char *, char **);
void           expandhtab     (Hashtab);
vptr           gethnode       (char *, Hashtab);
void           freehtab       (Hashtab, FFunc);
vptr           remhnode       (char *, Hashtab);
void           insnode        (Lklist, Lknode, vptr);
void           addnodeinorder (Lklist, char *);
vptr           remnode        (Lklist, Lknode);
vptr           uremnode       (Lklist, Lknode);
void           chuck          (char *);
vptr           getnode        (Lklist);
vptr           ugetnode       (Lklist);
void           freetable      (Lklist, FFunc);
char          *ztrstr         (char *, char *);
void           inslist        (Lklist, Lknode, Lklist);
int            countnodes     (Lklist);
void           taddchr        (int);
void           taddstr        (char *);
void           taddint        (int);
void           taddnl         (void);
char          *getpermtext    (struct node *);
char          *getjobtext     (struct node *);
void           gettext2       (struct node *);
void           getsimptext    (Cmd);
void           getredirs      (Cmd);
void           taddlist       (Lklist);
int            source         (char *);
void           sourcehome     (char *);
void           zerrnam        (char *, char *, char *, int);
void           zerr           (char *, char *, int);
void           niceputc       (int, FILE *);
void           intr           (void);
void           noholdintr     (void);
void           holdintr       (void);
char          *findpwd        (char *);
char          *fixpwd         (char *);
int            ispwd          (char *);
char          *xsymlink       (char *);
char         **slashsplit     (char *);
int            islink         (char *);
int            xsymlinks      (char *, int);
void           fprintdir      (char *, FILE *);
void           printdir       (char *);
void           printdircr     (char *);
int            finddir        (char *);
void           adduserdir     (char *, char *);
int            dircmp         (char *, char *);
int            ddifftime      (time_t, time_t);
void           scanjobs       (void);
void           preprompt      (void);
int            arrlen         (char **);
void           checkmailpath  (char **);
void           saveoldfuncs   (char *, Cmdnam);
void           newcmdnamtab   (void);
void           freecmdnam     (vptr);
void           freecompctl    (vptr);
void           freestr        (vptr);
void           freeanode      (vptr);
void           freepm         (vptr);
void           restoretty     (void);
void           gettyinfo      (struct ttyinfo *);
void           settyinfo      (struct ttyinfo *);
void           sanetty        (struct ttyinfo *);
void           adjustwinsize  (void);
int            zyztem         (char *, char *);
int            waitfork       (void);
int            movefd         (int);
void           redup          (int, int);
void           settrap        (int, List);
void           unsettrap      (int);
void           dotrap         (int);
void           ztrncpy        (char *, char *, int);
void           strucpy        (char **, char *);
void           struncpy       (char **, char *, int);
int            checkrmall     (char *);
int            getquery       (void);
void           spscannodis    (char *, char *);
void           spscan         (char *, char *);
void           spckword       (char **, char **, char **, int, int);
int            ztrftime       (char *, int, char *, struct tm *);
char          *join           (char **, int);
char          *spacejoin      (char **);
char          *colonjoin      (char **);
char         **colonsplit     (char *);
char         **spacesplit     (char *);
List           getshfunc      (char *);
vptr           allocnode      (int);
vptr           dupstruct      (vptr);
void           freestruct     (vptr);
Lklist         duplist        (Lklist, VFunc);
char         **mkarray        (char *);
void           feep           (void);
void           freearray      (char **);
int            equalsplit     (char *, char **);
void           simplifyright  (List);
void           inittyptab     (void);
char         **arrdup         (char **);
char          *spname         (char *);
int            mindist        (char *, char *, char *);
int            spdist         (char *, char *, int);
char          *zgetenv        (char *);
int            tulower        (int);
int            tuupper        (int);
int            gethostname    (char *, int);
void           setcbreak      (void);
int            getlineleng    (void);
void           unsetcbreak    (void);
void           attachtty      (long);
long           gettygrp       (void);
time_t         getlogtime     (struct utmp *, int);
void           watchlog2      (int, struct utmp *, char *);
void           watchlog       (int, struct utmp *, char **, char *);
int            ucmp           (struct utmp *, struct utmp *);
void           readwtab       (void);
void           dowatch        (void);
int            bin_log        (char *, char **, char *, int);
void           toggleliteralhistory (void);
void           uphistory      (void);
void           uplineorhistory (void);
void           uplineorsearch (void);
void           downlineorhistory (void);
void           downlineorsearch (void);
void           acceptlineanddownhistory (void);
void           downhistory    (void);
void           historysearchbackward (void);
void           historysearchforward (void);
void           beginningofbufferorhistory (void);
void           beginningofhistory (void);
void           endofbufferorhistory (void);
void           endofhistory   (void);
void           insertlastword (void);
char          *qgetevent      (int);
void           pushline       (void);
void           getline        (void);
void           historyincrementalsearchbackward (void);
void           historyincrementalsearchforward (void);
void           doisearch      (int);
void           acceptandinfernexthistory (void);
void           infernexthistory (void);
void           vifetchhistory (void);
int            getvisrchstr   (void);
void           vihistorysearchforward (void);
void           vihistorysearchbackward (void);
void           virepeatsearch (void);
void           virevrepeatsearch (void);
void           setterm        (void);
void           unsetterm      (void);
void           ungetkey       (int);
void           ungetkeys      (char *, int);
int            breakread      (int, char *, int);
unsigned int   getkey         (int);
unsigned char *zleread        (unsigned char *, unsigned char *, int);
int            getkeycmd      (void);
void           sendstring     (void);
Key            makefunckey    (int);
void           initxbindtab   (void);
char          *getkeystring   (char *, int *);
void           printbind      (char *, int);
void           printbinding   (char *, Key);
int            bin_bindkey    (char *, char **, char *, int);
void           freekey        (vptr);
void           drainoutput    (void);
void           selfinsert     (void);
void           selfinsertunmeta (void);
void           deletechar     (void);
void           backwarddeletechar (void);
void           vibackwarddeletechar (void);
void           vikillline     (void);
void           killwholeline  (void);
void           killbuffer     (void);
void           backwardkillline (void);
void           gosmacstransposechars (void);
void           transposechars (void);
void           poundinsert    (void);
void           acceptline     (void);
void           acceptandhold  (void);
void           killline       (void);
void           killregion     (void);
void           copyregionaskill (void);
void           yank           (void);
void           viputafter     (void);
void           yankpop        (void);
void           overwritemode  (void);
void           undefinedkey   (void);
void           quotedinsert   (void);
void           digitargument  (void);
void           negargument    (void);
void           universalargument (void);
void           copyprevword   (void);
void           sendbreak      (void);
void           undo           (void);
void           quoteregion    (void);
void           quoteline      (void);
char          *makequote      (char *);
int            executenamedcommand (void);
void           vijoin         (void);
void           viswapcase     (void);
void           vicapslockpanic (void);
void           visetbuffer    (void);
void           stradd         (char *);
int            putstr         (int);
char          *putprompt      (char *, int *, int);
void           beginningofline (void);
void           endofline      (void);
void           beginningoflinehist (void);
void           endoflinehist  (void);
void           forwardchar    (void);
void           backwardchar   (void);
void           setmarkcommand (void);
void           exchangepointandmark (void);
void           vigotocolumn   (void);
void           vimatchbracket (void);
void           viforwardchar  (void);
void           vibackwardchar (void);
void           viendofline    (void);
void           vibeginningofline (void);
void           vifindnextchar (void);
void           vifindprevchar (void);
void           vifindnextcharskip (void);
void           vifindprevcharskip (void);
void           virepeatfind   (void);
void           virevrepeatfind (void);
void           vifirstnonblank (void);
void           visetmark      (void);
void           vigotomark     (void);
void           vigotomarkline (void);
void           resetvideo     (void);
int            scrollwindow   (void);
void           refresh        (void);
void           refreshline    (int);
void           moveto         (int, int);
void           tcmultout      (int, int, int);
void           tc_rightcurs   (int);
void           tc_downcurs    (int);
void           tcout          (int);
void           tcoutarg       (int, int);
void           clearscreen    (void);
void           redisplay      (void);
void           trashzle       (void);
void           singlerefresh  (void);
void           singmoveto     (int);
int            streqct        (char *, char *);
int            usetab         (void);
void           completeword   (void);
void           menucompleteword (void);
void           listchoices    (void);
void           spellword      (void);
void           deletecharorlist (void);
void           expandword     (void);
void           expandorcomplete (void);
void           menuexpandorcomplete (void);
void           listexpand     (void);
void           reversemenucomplete (void);
void           acceptandmenucomplete (void);
void           docomplete     (int);
void           do_menucmp     (int);
char          *get_comp_string (void);
void           doexpansion    (char *, int, int);
void           gotword        (char *);
void           inststrlen     (char *, int);
void           addmatch       (char *);
void           addcmdmatch    (char *, char *);
void           addcmddirparam (char *, char *);
void           addcmdnodis    (char *, char *);
void           maketildelist  (char *);
DIR           *OPENDIR        (char *);
char          *dirname        (char *);
int            Isdir          (char *);
int            isdir          (char *, char *);
void           docompletion   (char *, int, int);
char         **get_user_var   (char *);
void           gen_matches_glob (char *, int);
void           gen_matches_reg (char *, int, int);
void           do_fignore     (char *);
void           do_ambiguous   (char *);
void           do_single      (char *);
void           do_ambig_menu  (char *);
int            strpfx         (char *, char *);
int            pfxlen         (char *, char *);
void           listmatches    (Lklist, char *);
void           selectlist     (Lklist);
int            doexpandhist   (void);
void           magicspace     (void);
void           expandhistory  (void);
char          *getcurcmd      (void);
void           processcmd     (void);
void           expandcmdpath  (void);
void           freemenu       (void);
int            inarray        (char *, char **);
void           sizeline       (int);
void           spaceinline    (int);
void           backkill       (int, int);
void           forekill       (int, int);
void           cut            (int, int, int);
void           backdel        (int);
void           foredel        (int);
void           setline        (char *);
void           sethistline    (unsigned char *);
int            findbol        (void);
int            findeol        (void);
void           findline       (int *, int *);
void           initundo       (void);
void           addundo        (void);
void           freeundo       (void);
int            hstrncmp       (char *, char *, int);
int            hstrcmp        (char *, char *);
char          *hstrnstr       (char *, char *, int);
int            vigetkey       (void);
int            getvirange     (int);
void           viaddnext      (void);
void           viaddeol       (void);
void           viinsert       (void);
void           viinsertbol    (void);
void           videlete       (void);
void           videletechar   (void);
void           vichange       (void);
void           visubstitute   (void);
void           vichangeeol    (void);
void           vichangewholeline (void);
void           viyank         (void);
void           viyankeol      (void);
void           vireplace      (void);
void           vireplacechars (void);
void           vicmdmode      (void);
void           viopenlinebelow (void);
void           viopenlineabove (void);
void           vioperswapcase (void);
void           virepeatchange (void);
void           viindent       (void);
void           viunindent     (void);
void           forwardword    (void);
void           viforwardword  (void);
void           viforwardblankword (void);
void           emacsforwardword (void);
void           viforwardblankwordend (void);
void           viforwardwordend (void);
void           backwardword   (void);
void           vibackwardword (void);
void           vibackwardblankword (void);
void           emacsbackwardword (void);
void           backwarddeleteword (void);
void           vibackwardkillword (void);
void           backwardkillword (void);
void           upcaseword     (void);
void           downcaseword   (void);
void           capitalizeword (void);
void           deleteword     (void);
void           killword       (void);
void           transposewords (void);
